import { feature } from 'topojson';
import { csv, json } from 'd3';

export const loadAndProcessData = () => 
  Promise
    .all([
      csv('informrisk.csv'),
      json('https://unpkg.com/world-atlas@1.1.4/world/50m.json')
    ])
    .then(([unData, topoJSONdata]) => {
      
      const rowById = unData.reduce((accumulator, d) => {
        accumulator[d['countrycode']] = d;
        return accumulator;
      }, {});
      
      const countries = feature(topoJSONdata, topoJSONdata.objects.countries);

      countries.features.forEach(d => {
        Object.assign(d.properties, rowById[+d.id]);
      });      
      
      return countries;
    });